#!/bin/sh
#
# Description: Daemon for read out of DvdPlayer in named PIPE '/tmp/DvdPlayer.out' and check press any key on RC.
#

VERSION="0.8beta-20170421"
####################################
####################################
## Local variables initialization
##

# Read config file
mos=/usr/local/etc/mos
[ -f $mos/etc/sleeptimer.conf ] && eval "$( cat $mos/etc/sleeptimer.conf | sed '/^$/d' )"

# Debug level for sleepD.sh
dbgD=$debug

####################################
####################################
##

# Debug log path
dbgD_log_path="/tmp/sleepD.log"

# Path of named PIPE for out of DvdPlayer
DPout="/tmp/DPfifo.out"

# Path of timestamp log of last press key on RC
RCout="/tmp/PressKey.log"

####################################
####################################
## The main check cycle
##
if [ $dbgD -ge 1 ] ; then echo "Version: $VERSION" > $dbgD_log_path ; fi
while true ; do
	read -r line < $DPout
	if [ $dbgD -eq 2 ] ; then echo ">>$line" >> $dbgD_log_path ; fi
	if echo "$line" | grep -qE "(: [^-].*$)" ; then
		if [ $dbgD -gt 0 ] ; then echo "$line" >> $dbgD_log_path ; fi
		date '+%s' > $RCout
	fi
done
