#!/bin/sh
#
# Description: Main check script of SleepTimer.
#

VERSION="0.8beta-20170421"
####################################
####################################
## Local variables initialization
##

# Read config file
mos=/usr/local/etc/mos
[ -f $mos/etc/sleeptimer.conf ] && eval "$( cat $mos/etc/sleeptimer.conf | sed '/^$/d' )"

# Debug level for sleepT.sh
dbgT=$debug

# Latency timer shutdown, minutes
time=$latency

####################################
####################################
##

# Timestamp log of last press key on RC
RCout="/tmp/PressKey.log"

# First initiated of timestamp log
if [ ! -e $RCout ] ; then date '+%s' > $RCout ; fi

# Debug log path
dbgT_log_path="/tmp/sleepT.log"

# Files for checking of changes
file_01="/tmp/appContext"

####################################
####################################
## Function for debugging
##
if [ -f $dbgT_log_path ] ; then 
	rm -f $dbgT_log_path
fi
logmsg (){ 
	if [ $dbgT -gt 0 ]; then   
		D=`date +"%F %T"`
		echo "[$D] $@" 
		echo "[$D] $@" >> $dbgT_log_path
	fi 
}

####################################
####################################
## Function for cheking disks activity
##
chkdsk (){ 
	local __resultvar=$1
	local i=""
	for j in $( ls /tmp/usbmounts ) ; do
		diskID=`expr substr $j 1 3`
		hash=`md5sum /sys/block/$diskID/stat | awk '{ print $1}'`
		logmsg "63 $diskID: $hash"
		summ_hash=`echo $summ_hash$hash`
	done
	#logmsg "66 Total: $summ_hash"
	local result="$summ_hash"
    eval $__resultvar="'$result'"
	summ_hash=""
}

sleep 10

## First start line = 75!!!!!!!!!!
logmsg "75 First start sleepTimer ($VERSION)"
####################################
####################################
## First start timer daemon
##
logmsg "80 Daemon initialization"						
i=0

check1_old=`md5sum $file_01 | awk '{ print $1}'`
check2_old=`md5sum $RCout | awk '{ print $1}'`
chkdsk iostat_old

until [ $i -eq $time ]
do
	####################################
	####################################
	## Main check cycle
	##
	logmsg "93 Timer = $i"
	logmsg "94 Waiting..."
	sleep 60
		
	####################################
	####################################
	## What is being done player: playback Video/Audio/Picture/IPTV, navigation menu, copying files or system idle?
	## Check changes files: /tmp/appContext, /tmp/PressKey.log
	##
	logmsg "102 Check changes in files"
	
	check1_new=`md5sum $file_01 | awk '{ print $1}'`
	if [ "$check1_new" = "$check1_old" ] ; then
		####################################
		####################################
		## File /tmp/appContext has not changed!
		##
		logmsg "110 /tmp/appContext = not changed"				
	
		####################################
		####################################
		## Check content of file /tmp/appContext
		##
		systemstate=`grep video_playback $file_01 | awk '{ print $1 }'`
		#logmsg "117 $systemstate"
		if [ "$systemstate" = "video_playback" ] ; then
			####################################
			####################################
			## Player set video playback  - reset timer
			##
			logmsg "123 Playback video -> reset timer"
			i=0
			check1_old=$check1_new
			continue
		fi
				
		systemstate=`grep music_playback $file_01 | awk '{ print $1 }'`
		#logmsg "130 $systemstate"
		if [ "$systemstate" = "music_playback" ] ; then
			####################################
			####################################
			## Player set music playback - reset timer
			##
			logmsg "136 Music playback -> reset timer"
			i=0
			check1_old=$check1_new
			continue
		fi
		
		systemstate=`grep picture_playback $file_01 | awk '{ print $1 }'`
		#logmsg "143 $systemstate"
		if [ "$systemstate" = "picture_playback" ] ; then
			####################################
			####################################
			## Player set picture playback - reset timer
			##
			logmsg "149 Picture playback -> reset timer"
			i=0
			check1_old=$check1_new
			continue
		fi
				
		systemstate=`grep IMSAP $file_01 | awk '{ print $1 }'`
		#logmsg "156 $systemstate"							
		if [ "$systemstate" = "IMSAP" ] ; then
			systemstate=`grep video $file_01 | awk '{ print $1 }'`
			#logmsg "159 $systemstate"
			if [ "$systemstate" = "video" ] ; then
				####################################
				####################################
				## Player IPTV playback - reset timer 
				##
				logmsg "165 IPTV playback -> reset timer"
				i=0
				check1_old=$check1_new
				continue
			fi
						
			systemstate=`grep normal  $file_01 | awk '{ print $1 }'`
			#logmsg "172 $systemstate"							
			if [ "$systemstate" = "normal" ] ; then
				####################################
				####################################
				## Player navigation menu, copies files or system idle
				##
				check2_new=`md5sum $RCout | awk '{ print $1}'`
				if [ "$check2_new" = "$check2_old" ] ; then
					####################################
					####################################
					## Check disks activity
					##
					chkdsk iostat_new
					if [ "$iostat_old" = "$iostat_new" ] ; then
						####################################
						####################################
						## Player in idle - increase timer
						##
						logmsg "190 System idle -> increase timer"
						i=`expr $i + 1`
						iostat_old=$iostat_new
						iostat_new=""
					else
						####################################
						####################################
						## Player coping file - reset timer
						##
						logmsg "199 Disks is active -> reset timer"
						i=0
						iostat_old=$iostat_new
						iostat_new=""
						continue
					fi
				else
					####################################
					####################################
					## Player in navigation menu - reset timer 
					##
					logmsg "210 /tmp/PressKey.log = changed"
					logmsg "211 Menu navigation -> reset timer"
					i=0
					check2_old=$check2_new
					continue
				fi
				
			fi
		fi						
		
		systemstate=`grep unknown $file_01 | awk '{ print $1 }'`
		#logmsg "221 $systemstate"
		if [ "$systemstate" = "unknown" ] ; then
			####################################
			####################################
			## Player navigation menu, copies files or idle after playback Video/Audio/Picture  
			##
			check2_new=`md5sum $RCout | awk '{ print $1}'`
			if [ "$check2_new" = "$check2_old" ] ; then
				####################################
				####################################
				## Check disks activity
				##
				chkdsk iostat_new
				if [ "$iostat_old" = "$iostat_new" ] ; then
					####################################
					####################################
					##  Player in idle after playback - increase timer
					##
					logmsg "239 System idle after playback -> increase timer"
					i=`expr $i + 1`
					iostat_old=$iostat_new
					iostat_new=""
				else
					####################################
					####################################
					## Player coping file - reset timer
					##
					logmsg "248 Disks is active -> reset timer"
					i=0
					iostat_old=$iostat_new
					iostat_new=""
					continue
				fi
			else
				####################################
				####################################
				## Player in navigation menu - reset timer 
				##
				logmsg "259 /tmp/PressKey.log = changed"
				logmsg "260 Menu navigation -> reset timer"
				i=0
				check2_old=$check2_new
				continue
			fi
		fi
	else
		####################################
		####################################
		## File /tmp/appContext has changed - reset timer
		##
		logmsg "271 /tmp/appContext = changed -> reset timer"
		i=0
		check1_old=$check1_new
		continue
	fi
done
####################################
####################################
## Power Off......
##
logmsg "281 Power Off..."
# Wi-Fi off and unload driver
if lsmod | grep -Eq '^8192eu ' ; then
	/usr/bin/killall wpa_supplicant
	/sbin/ifconfig wlan0 down
	/sbin/rmmod 8192eu
fi
# Get firmware version
#FW=`cat /usr/share/bin/boot_fw.conf | grep 'fw' | cut -d '=' -f2`
#logmsg "290 [$FW] firmware"
# Get keycodes from sleeptimer.conf or irfake.conf 
if [ "$UPkeyCode" = "" ] ; then UPkeyCode=`cat /usr/local/etc/irfake/irfake.conf |grep -iE "^[^#]"0".*\<UP\>" | cut -d ',' -f3 | tr -d \"` ; fi
if [ "$PWRkeyCode" = "" ] ; then PWRkeyCode=`cat /usr/local/etc/irfake/irfake.conf |grep -iE "^[^#]"0".*\<POWER.*\>" | cut -d ',' -f3 | tr -d \"` ; fi
logmsg "294 [UP]=$UPkeyCode, [POWER]=$PWRkeyCode"
echo 0x$UPkeyCode > /sys/devices/platform/VenusIR/fakekey
sleep 1
echo 0x$PWRkeyCode > /sys/devices/platform/VenusIR/fakekey
sleep 5

logmsg "300 Abnormal exit!!!"
